/**
 * Created by sff on 2018/9/7.
 */
$(function(){
    //操作指引
    $(".textGuide-2ut31").click(function(){
        $(".app-2Ovjg").show();
    });
    $(".footer-2T_5k button").click(function(){
        $(".app-2Ovjg").hide();
    });
    //切换审批图标
    $(".selectIcon-2A4f1").click(function(){
        $(".box-17HPJ").toggle();
    });
    $("body").on("click",".list-39QqD span",function(){
        var imgsrc=$(this).find("img").attr("src");
        $('#img-path').val(imgsrc);
        $(".selectIcon-2A4f1 img").attr("src",imgsrc);
        $(".box-17HPJ").hide();
    });

    //切换选项卡
    $(".ivu-tabs-nav .ivu-tabs-tab").click(function(){
        var idNum=$(this).attr('data-id');
        if(idNum==1){
            $(this).parents(".ivu-tabs-nav").find(".ivu-tabs-ink-bar").css("transform","translate3d(0px, 0px, 0px)");
            $(this).parents(".ivu-tabs").find(".ivu-tabs-content").css("transform","translateX(0%)");
        }else{
            $(this).parents(".ivu-tabs-nav").find(".ivu-tabs-ink-bar").css("transform","translate3d(166px, 0px, 0px)");
            $(this).parents(".ivu-tabs").find(".ivu-tabs-content").css("transform","translateX(-100%)");
        }
        $(this).addClass('ivu-tabs-tab-active').siblings().removeClass('ivu-tabs-tab-active');
    });

    layui.use(['laydate', 'laypage', 'layer', 'table', 'carousel', 'upload', 'element','form'], function () {
        var laydate = layui.laydate //日期
            , laypage = layui.laypage //分页
            , layer = layui.layer //弹层
            , table = layui.table //表格
            , carousel = layui.carousel //轮播
            , upload = layui.upload //上传
            , element = layui.element//元素操作
            , form = layui.form;//表单操作

        //拖动排序
        $('#wrap').DDSort({
            target: '.wraper-2mWzK',
            floatStyle: {
                'border': '1px solid #ccc',
                'background-color': '#fff'
            }
        });
        //删除通用审批中的模板
        $("#wrap").on("click",".close-2C5YM",function(){
            //console.log($(this).parents(".wraper-2mWzK").attr('data-code'));
            if($(this).parents(".wraper-2mWzK").attr('data-code').length>0){
                layer.alert('特定字段不可删除，会影响程序运行');
                return false;
            }else{
                $(this).parents(".wraper-2mWzK").remove();
                if($("#wrap .wraper-2mWzK").length==0){
                    $(".sp-blank").css('display','block');
                }else{
                    $(".sp-blank").hide();
                }
            }

        });

        //通用审批模板点击选中状态
        $("body").on("click",".wraper-2mWzK",function(){

            //给模板中 赋值单选的选项
            var itemStr='';
            $.each($(".right-3vjE2 .single-item"),function(id,item){
                itemStr+=$(item).find(".ivu-input").val()+',';
            });
            itemStr=itemStr.substring(0,itemStr.length-1);
            //console.log(itemStr);

            $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-values",itemStr);

            $(".select-1_MQq").parents(".wraper-2mWzK").find(".hide-content").html($(".right-3vjE2").find(".ivu-tabs-tabpane").eq(0).html());
            console.log($(".right-3vjE2").find(".ivu-tabs-tabpane").eq(0).html())
            $(".main-240BC").removeClass("valid-HhEF8");
            $(".ivu-form-item-error").parents(".wraper-2mWzK").find(".main-240BC").addClass("valid-HhEF8");

            //赋值完 再给点击的新的字段class 'select-1_MQq'
            $(".main-240BC").removeClass("select-1_MQq");
            $(this).find(".main-240BC").addClass("select-1_MQq");

            $(".right-3vjE2").find(".ivu-tabs-tabpane").eq(0).html($(this).find(".hide-content").html());
            form.render();
            //右侧切换
            $(".right-3vjE2").find(".ivu-tabs-ink-bar,.ivu-tabs-content").css("transform","translate3d(0px, 0px, 0px)");
        });

        //添加审批分组
        $(".add-23Qk6").click(function(){
            layer.open({
                title: '添加分组', //不显示标题
                type: 1,
                content: $('#add-modal'),
                area: ['420px', '240px'], //宽高
                btn: ['确定', '取消'],
                yes: function(index, layero){
                    if($("#add-gounp").val()&&$("#add-gounp").val()!='请输入...'){
                        $("#group-sel").append('<option selected value="'+$("#add-gounp").val()+'">'+$("#add-gounp").val()+'</option>');
                        layer.close(index); //如果设定了yes回调，需进行手工关闭
                        $("#add-modal .ivu-form-item").removeClass("ivu-form-item-error");
                        form.render();
                    }else{
                        $("#add-modal .ivu-form-item").addClass("ivu-form-item-error");
                    }
                }
            });
        });

        //添加通用审批模板
        $("body").on("click",".btn-10TCj",function(){
            var itemStr='';
            $.each($(".right-3vjE2 .single-item"),function(id,item){
                itemStr+=$(item).find(".ivu-input").val()+',';
            });
            itemStr=itemStr.substring(0,itemStr.length-1);
            $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-values",itemStr);
            var currInd=$(this).attr("data-temp");
            var temp=$("#"+currInd).clone();
            temp.attr("id","");
            temp.removeClass("hide-model");
            $(".main-240BC").removeClass("select-1_MQq");
            temp.find(".main-240BC").addClass("select-1_MQq");
            $("#wrap").append(temp);
            $(".right-3vjE2").find(".ivu-tabs-tabpane").eq(0).html(temp.find(".hide-content").html());
            form.render();
            $(".right-3vjE2").find(".ivu-tabs-ink-bar,.ivu-tabs-content").css("transform","translate3d(0px, 0px, 0px)");
            $("#sp-wrap").scrollTop($("#sp-wrap")[0].scrollHeight);
            if($("#wrap .wraper-2mWzK").length==0){
                $(".sp-blank").css('display','block');
            }else{
                $(".sp-blank").hide();
            }
        });

        //验证必填项
        $("body").on("blur",".ivu-form-item-required .ivu-input",function(){
            if(!$(this).val()){
                $(this).parents(".ivu-form-item-required").addClass("ivu-form-item-error");
            }else{
                $(this).parents(".ivu-form-item-required").removeClass("ivu-form-item-error");
            }
        });

        //修改名称
        $(".right-3vjE2 .ivu-tabs-tabpane").eq(0).on("keyup","input.ivu-input",function(){
            if(!$(this).parents(".ivu-form-item").hasClass("single-item")){

                //字段名
                if($(this).hasClass('ivu-name')){
                    $(".select-1_MQq .leftFont-1gidz").html($(this).val());
                    $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-name",$(this).val());
                }

                //字段code
                if($(this).hasClass('ivu-code')){
                    $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-code",$(this).val());
                }
            }

            $(this).attr("value",$(this).val());

        });

        //修改名称 （后来加的 不需要啦 改用上面的方式）
        //$(".right-3vjE2 .ivu-tabs-tabpane").eq(0).on("keyup","input.ivu-name",function(){
        //    if(!$(this).parents(".ivu-form-item").hasClass("single-item")){
        //        $(".select-1_MQq .leftFont-1gidz").html($(this).val());
        //        $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-name",$(this).val());
        //    }
        //    $(this).attr("value",$(this).val());
        //});
        //
        ////将程序识别名字 同步给父级（便于提交表单时获取数据）
        //$(".right-3vjE2 .ivu-tabs-tabpane").eq(0).on("keyup","input.ivu-code",function(){
        //    if(!$(this).parents(".ivu-form-item").hasClass("single-item")){
        //        $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-code",$(this).val());
        //    }
        //    $(this).attr("value",$(this).val());
        //});
        //修改说明
        $(".right-3vjE2 .ivu-tabs-tabpane").eq(0).on("keyup","textarea.ivu-input",function(){
            $(".select-1_MQq .sub-1RO52").html($(this).val());
            $(this).html($(this).val());
            $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-dcr",$(this).val());
        });

        ////修改select的选项  (后来加的 不需要啦)
        //$('body').on("keyup",'input.sel-potion',function(){
        //    var optionArr = [];
        //    var the_this = $(this);
        //    var the_parent = $(this).parents('.sel-potion-div');
        //    var all_option = the_parent.find('.sel-potion');
        //    $.each(all_option,function(key,val){
        //        var objname = {};
        //        objname = $(val).val();
        //        optionArr.push(objname);
        //    });
        //
        //    var optionStr = optionArr.join(',');
        //
        //    $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-values",optionStr);
        //
        //});

        //监听checkbox
        form.on('checkbox', function(data){
            $(data.elem).attr("checked",data.elem.checked);
            if($(data.elem).attr("title")=='必填'){
                if(data.elem.checked){
                    $(".select-1_MQq .leftFont-1gidz").addClass("required-2qHSI");
                    $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-req",1);
                }else{
                    $(".select-1_MQq .leftFont-1gidz").removeClass("required-2qHSI");
                    $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-req",2);
                }
            }
            //$(".select-1_MQq").parents(".wraper-2mWzK").attr("data-req",data.elem.checked);
        });
        //删除单选
        $(".right-3vjE2 .ivu-tabs-tabpane").eq(0).on("click",".ivu-icon-close-circled",function(){
            if($(".right-3vjE2 .single-item").length>1){
                $(this).parents(".single-item").remove();
            }else{
                layer.open({
                    content: '不能再删除了~'
                });
            }
        });
        //添加单选
        $(".right-3vjE2 .ivu-tabs-tabpane").eq(0).on("click",".ivu-btn.ivu-btn-dashed",function(){
            var itemtemp=$("#itemTemp").clone();
            itemtemp.attr("id","");
            itemtemp.removeClass("hide-model");
            $(this).parents(".ivu-form-item").before(itemtemp);
        });

        //修改审批表单名称
        $("#sp-top-name").on("keyup",function(){
            $(".center-21fuu .head-3pkKN").html($(this).val());
        });

        //获取数据
        function getData(){
            var dataList=$("#wrap .wraper-2mWzK"),
                dataArr=[];
            var itemStr='';
            $.each($(".right-3vjE2 .single-item"),function(id,item){
                itemStr+=$(item).find(".ivu-input").val()+',';
            });
            itemStr=itemStr.substring(0,itemStr.length-1);
            $(".select-1_MQq").parents(".wraper-2mWzK").attr("data-values",itemStr);
            $.each(dataList,function(id,item){
                dataArr.push({ type: $(item).attr("data-type"), code: $(item).attr("data-code"), name: $(item).attr("data-name"), placeholder:$(item).attr("data-dcr"),required:$(item).attr("data-req"),values:$(item).attr("data-values").split(",")});
            });
            return dataArr;
        }
        $("#save-btn").click(function(){
            var id = $('#id').val();
            var sp_top_name = $('#sp-top-name').val();
            var sp_top_content = $('#sp-top-content').val();
            var img_path = $('#img-path').val();
            var form_files = JSON.stringify(getData());
            var type_id = $('#sp-type').val();

            if(!sp_top_name){
                layer.alert('请填写审批名称');
                return false;
            }

            if(!type_id){
                layer.alert('请选择审批分类');
                return false;
            }

            console.log(id);
            console.log(img_path);
            console.log(getData());
            console.log(form_files);

            $.ajax({
                url:'/papi/Form/form_save',
                type:'post',
                data:{id:id,name:sp_top_name,content:sp_top_content,type_id:type_id,logo:img_path,fields:form_files},
                dataType:'json',
                success:function(res) {
                     console.log(res);
                    if(res.code===200) {
                        layer.alert('操作成功');
                        setTimeout(function(){
                            location.href="/oa/Form/index";
                        },1500);
                    }else if(res.code===201) {
                        layer.alert(res.msg);
                    }
                }
            })
        });
        //去设置审批流程
        $('#set-process').click(function(){
            $.ajax({
                url:'/papi/Form/form_save',
                type:'post',
                data:{id:$('#id').val(),name:$('#sp-top-name').val(),content:$('#sp-top-content').val(),type_id:$('#sp-type').val(),logo:$('#img-path').val(),fields:JSON.stringify(getData())},
                dataType:'json',
                success:function(res) {
                    console.log(res);
                    if(res.code===200) {
                        console.log(res.data.formid);
                        location.href="/oa/Process/add?form_id="+res.data.formid;
                    }else if(res.code===201) {
                        layer.alert(res.msg);
                    }
                }
            })
        });
    });
});
